namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using Eco.Gameplay.Blocks;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.Components.Auth;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Economy;
    using Eco.Gameplay.Housing;
    using Eco.Gameplay.Interactions;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Minimap;
    using Eco.Gameplay.Objects;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Property;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Gameplay.Pipes.LiquidComponents;
    using Eco.Gameplay.Pipes.Gases;
    using Eco.Gameplay.Systems.Tooltip;
    using Eco.Shared;
    using Eco.Shared.Math;
    using Eco.Shared.Serialization;
    using Eco.Shared.Utils;
    using Eco.Shared.View;
    using Eco.Shared.Items;
    using Eco.Gameplay.Pipes;
    using Eco.World.Blocks;
    
    [Serialized]    
    [RequireComponent(typeof(AttachmentComponent))]
    [RequireComponent(typeof(PropertyAuthComponent))]          
    public partial class TrafficConeAObject : WorldObject
    {
        static TrafficConeAObject()
        {
             WorldObject.AddOccupancy<TrafficConeAObject>(new List<BlockOccupancy>(){

                new BlockOccupancy(new Vector3i(0, 0, 0), typeof(SolidWorldObjectBlock)),
                new BlockOccupancy(new Vector3i(0, 1, 0), typeof(SolidWorldObjectBlock)),
                }); 
        }
		
        public override string FriendlyName { get { return "Traffic Cone"; } } 


        protected override void Initialize()
        {
           
        }

        public override void Destroy()
        {
            base.Destroy();
        }
       
    }

    [Serialized]
    public partial class TrafficConeAItem : WorldObjectItem<TrafficConeAObject>
    {
        public override string FriendlyName { get { return "Traffic Cone"; } } 
        public override string Description { get { return ""; } }

        static TrafficConeAItem()
        {
            
        }
        
    }


    [RequiresSkill(typeof(PrimitiveMechanicsSkill), 1)]
    public partial class CôneRecipe : Recipe
    {
        public CôneRecipe()
        {
            this.Products = new CraftingElement[]
            {
                new CraftingElement<TrafficConeAItem>(),
            };

            this.Ingredients = new CraftingElement[]
            {
				new CraftingElement<PlantFibersItem>(typeof(PrimitiveMechanicsEfficiencySkill), 40, PrimitiveMechanicsEfficiencySkill.MultiplicativeStrategy),
                new CraftingElement<FireweedShootsItem>(typeof(PrimitiveMechanicsEfficiencySkill), 10, PrimitiveMechanicsEfficiencySkill.MultiplicativeStrategy),
				
            };
           this.CraftMinutes = CreateCraftTimeValue(typeof(CôneRecipe), Item.Get<TrafficConeAItem>().UILink(), 2, typeof(PrimitiveMechanicsSpeedSkill));    
		   
           this.Initialize("Traffic Cone", typeof(CôneRecipe));
           CraftingComponent.AddRecipe(typeof(WainwrightTableObject), this);
        }
    }
}